﻿Imports System.Reflection
Public Class CustomMethodMediator(Of TEventArgs As EventArgs)
    Inherits MethodMediator(Of TEventArgs)

    Private Function GetHandlerMethod() As MethodInfo
        Dim Flags = Reflection.BindingFlags.Instance Or Reflection.BindingFlags.NonPublic
        If Me.IsSynchronized Then
            Return Me.GetType.GetMethod("OnSynchronizedEvent", Flags)
        ElseIf Me.IsAsynchronous Then
            Return Me.GetType.GetMethod("OnAsynchronousEvent", Flags)
        Else
            Return Me.GetType.GetMethod("OnSynchronousEvent", Flags)
        End If
    End Function
    Protected Overrides Function CreateHandler() As [Delegate]
        Dim HandlerMethod = Me.GetHandlerMethod
        Return [Delegate].CreateDelegate(Me.EventType, Me, HandlerMethod)
    End Function

End Class
