﻿Imports System.Windows.Forms.Design
Imports System.Drawing.Design
Imports EventBindings.Extensions

Namespace Design
    Public Class EventBindingTypeEditor
        Inherits UITypeEditor

        Public Overrides Function EditValue(ByVal context As ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object

            If context Is Nothing Then Return value
            Dim UIService As IWindowsFormsEditorService = Nothing
            If Not provider.TryGetService(Of IWindowsFormsEditorService)(UIService) Then Return value
            If Not TypeOf value Is EventBinding Then Return value

            Dim Dlg As New EventBindingDialog
            Dim Binding = DirectCast(value, EventBinding)
            Dlg.Fill(Binding, provider.GetOrCreateEventBindingServiceProvider)
            UIService.ShowDialog(Dlg)
            Return Binding

        End Function

        Public Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            Return UITypeEditorEditStyle.Modal
        End Function

    End Class
End Namespace
