﻿Imports System.Windows.Forms.Design
Imports System.Drawing.Design
Imports EventBindings.Extensions

Namespace Design
    Public Class EventBindingsTypeEditor
        Inherits UITypeEditor

        Public Overrides Function EditValue(ByVal context As ITypeDescriptorContext, ByVal provider As IServiceProvider, ByVal value As Object) As Object

            If context Is Nothing Then Return value
            Dim UIService As IWindowsFormsEditorService = Nothing
            If Not provider.TryGetService(Of IWindowsFormsEditorService)(UIService) Then Return value
            If Not TypeOf context.PropertyDescriptor Is EventBindingDescriptor Then Return value

            Dim BindingDescritor = DirectCast(context.PropertyDescriptor, EventBindingDescriptor)
            Dim Dlg As New EventBindingsDialog
            Dlg.EventDataForCreation = BindingDescritor.Event
            Dlg.Fill(TryCast(value, IEnumerable(Of EventBinding)), provider.GetOrCreateEventBindingServiceProvider)

            UIService.ShowDialog(Dlg)
            Return Dlg.Bindings

        End Function

        Public Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            Return UITypeEditorEditStyle.Modal
        End Function
    End Class
End Namespace

