﻿Imports System.Windows.Forms.Design
Imports System.Drawing.Design
Imports EventBindings.Extensions

Namespace Design
    Public Class HandlingDataTypeEditor
        Inherits UITypeEditor

        Public Overrides Function EditValue(ByVal context As ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object

            If context Is Nothing Then Return value
            Dim UIService As IWindowsFormsEditorService = Nothing
            If Not provider.TryGetService(Of IWindowsFormsEditorService)(UIService) Then Return value
            If Not TypeOf value Is HandlingData Then Return value

            Dim Box As New HandlingDataBox
            Dim handling = DirectCast(value, HandlingData)
            If TypeOf context.Instance Is EventBinding Then
                Box.Fill(DirectCast(context.Instance, EventBinding), provider.GetOrCreateEventBindingServiceProvider)
            Else
                Box.Fill(handling, provider.GetOrCreateEventBindingServiceProvider)
            End If
            UIService.DropDownControl(Box)
            Return handling

        End Function

        Public Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            Return UITypeEditorEditStyle.DropDown
        End Function
        Public Overrides ReadOnly Property IsDropDownResizable As Boolean
            Get
                Return True
            End Get
        End Property
    End Class
End Namespace

