﻿Imports System.Windows.Forms.Design
Imports System.Drawing.Design
Imports EventBindings.Extensions

Namespace Design
    Public Class MediatorFactoryTypeEditor
        Inherits UITypeEditor

        Public Overrides Function EditValue(ByVal context As ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object

            If context Is Nothing Then Return value
            Dim UIService As IWindowsFormsEditorService = Nothing
            If Not provider.TryGetService(Of IWindowsFormsEditorService)(UIService) Then Return value
            If Not TypeOf context.Instance Is MediationData Then Return value

            Dim mediation = DirectCast(context.Instance, MediationData)

            Dim Box As New ListBox
            Box.IntegralHeight = False
            Box.Size = New Size(150, 200)
            Dim Controller As New ListBoxController(Of IEventMediatorFactory)(Box)
            Controller.Items = provider.GetOrCreateEventBindingServiceProvider.GetMediatorFactories
            Controller.SelectedItem = mediation.Factory
            UIService.DropDownControl(Box)
            Return Controller.SelectedItem

        End Function

        Public Overrides Function GetEditStyle(ByVal context As ITypeDescriptorContext) As UITypeEditorEditStyle
            Return UITypeEditorEditStyle.DropDown
        End Function
        Public Overrides ReadOnly Property IsDropDownResizable As Boolean
            Get
                Return True
            End Get
        End Property
    End Class
End Namespace