﻿Namespace Design
    Public Class ListBoxController(Of TItem)
        Inherits ListControlController(Of TItem, ListBox)

        Public Sub New(ByVal listBox As ListBox)
            MyBase.New(listBox)
        End Sub
        Public Sub New(ByVal listBox As ListBox, ByVal selectionHandler As Action(Of TItem))
            MyBase.New(listBox, selectionHandler)
        End Sub

        Protected Overrides Sub FillControl()
            Me._ListControl.Items.Clear()
            If Me._Items Is Nothing Then Exit Sub
            For Each Item In Me._Items
                Me._ListControl.Items.Add(Item)
            Next
            Me._ListControl.SelectedItem = Me._SelectedItem
        End Sub
        Protected Overrides Sub SetControlSelection()
            Me._ListControl.SelectedItem = Me._SelectedItem
        End Sub
        Protected Overrides Function GetSelectedItem() As TItem
            If Me._ListControl.SelectedItem Is Nothing Then Return Nothing
            Return DirectCast(Me._ListControl.SelectedItem, TItem)
        End Function
    End Class
End Namespace
