﻿Imports System.Globalization
Imports System.ComponentModel.Design
Imports EventBindings.Extensions

Public Class EventBindingConverter
    Inherits ExpandableObjectConverter


    Public Overrides Function CanConvertTo(ByVal context As ITypeDescriptorContext, ByVal destinationType As Type) As Boolean
        If destinationType Is GetType(String) Then Return True
        Return MyBase.CanConvertTo(context, destinationType)
    End Function

    Public Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
        If destinationType Is GetType(String) AndAlso TypeOf value Is EventBinding Then
            Dim Binding = DirectCast(value, EventBinding)
            Return Binding.GetName(context.GetService(Of IReferenceService))
        End If
        Return MyBase.ConvertTo(context, culture, value, destinationType)
    End Function
End Class