﻿Imports System.Globalization
Imports System.ComponentModel.Design
Imports EventBindings.Extensions

Public Class EventPropertyConverter
    Inherits ArrayConverter ' ExpandableObjectConverter

    Private Function Format(ByVal value As Object, ByVal serviceProvider As IServiceProvider) As String
        If value Is Nothing OrElse Not TypeOf value Is IEnumerable Then Return String.Empty
        Dim ReferenceService = serviceProvider.GetService(Of IReferenceService)()
        Dim Formatted As String = String.Empty
        For Each Item In DirectCast(value, IEnumerable)
            If Item Is Nothing Then Continue For
            Dim ItemName As String = ReferenceService.GetAnyName(Item)
            Formatted.AppendWithWhiteSpaceSeparator(ItemName, ", ")
        Next
        Return Formatted
    End Function

    Public Overrides Function CanConvertTo(ByVal context As ITypeDescriptorContext, ByVal destinationType As Type) As Boolean
        If destinationType Is GetType(String) Then Return True
        Return MyBase.CanConvertTo(context, destinationType)
    End Function

    Public Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
        If destinationType Is GetType(String) Then
            Return Me.Format(value, context)
        End If
        Return MyBase.ConvertTo(context, culture, value, destinationType)
    End Function
End Class
